const webpackConfig = require('../../webpack.config.js')

module.exports = {

  title: 'docs',
  description: 'Vue-powered text highlighting',
  base: '/vue-mark-text/',
  dest: 'doc/.vuepress/dist',

  themeConfig: {
    navbar: false,
    search: false,
    sidebar: [
      [ '/', 'vue-mark-text' ],
      [ '/example.html', 'Example' ],
      [ '/controller.html', 'Controller' ],
      [ '/subject.html', 'Subject' ],
      [ '/misc.html', 'Misc' ],
    ]
  },

  configureWebpack: config => {

    const packageWebpack = webpackConfig({ mode: config.mode })

    for (const rule of packageWebpack.module.rules) {
      if (!config.module.rules.find(configRule => String(configRule.test) === String(rule.test) ))
        config.module.rules.push(rule)
    }
    config.plugins.push(...packageWebpack.plugins)
    for (const prop in packageWebpack.resolve) {
      if (!config.resolve[prop]) {
        Object.assign(config.resolve[prop], packageWebpack.resolve[prop])
      } else if (prop === 'alias') {
        config.resolve[prop] = {
          ...config.resolve[prop],
          ...packageWebpack.resolve[prop],
        }
      } else if (prop === 'extensions') {
        config.resolve[prop] = Array.from(new Set([
          ...config.resolve[prop],
          ...packageWebpack.resolve[prop]
        ]))
      }
    }

  }

}
